#include "Log.h"

Log::Log(const char* filename) {
    this->filename = filename;
}

void Log::toggleWrite(bool writing) {
    
    this->writing = writing;

    if(writing) {
        outputFile.open(filename);
        
        timer.Reset();
        timer.Start();

        outputFile << "time,ball count,intake sensor,helix sensor,shooter counter,shooter state,intake state,intake current\n";
    }
    else {
        outputFile.close();
        timer.Stop();
    }
}

void Log::process() {
    if(writing) {
        outputFile << timer.Get() << ",";
        outputFile << (int)ballCount << ",";
        outputFile << (int)intakeSensor << ",";
        outputFile << (int)helixSensor << ",";
        outputFile << (int)shooterCounter << ",";
        outputFile << (int)shooterState << ",";
        outputFile << (int)intakeState << ",";
        outputFile << (double)intakeCurrent << "\n";
    }
}

void Log::setBallCount(int count) {
    ballCount = count;
}

void Log::setHelixSensor(bool helix) {
    helixSensor = helix;
}

void Log::setIntakeSensor(bool intake) {
    intakeSensor = intake;
}

void Log::setShooterCounter(int counter) {
    shooterCounter = counter;
}

void Log::setIntakeState(int intakeState) {
    this->intakeState = intakeState;
}

void Log::setShooterState(int shooterState) {
    this->shooterState = shooterState;
}

void Log::setIntakeCurrent(double intakeCurrent) {
    this->intakeCurrent = intakeCurrent;
}