#pragma once

#include "Feedback.h"
#include "Drive.h"
#include "GamePiece.h"
#include <iostream>
#include <frc/DriverStation.h>
#include <frc/Timer.h>
#include "frc/smartdashboard/Smartdashboard.h"
#include "networktables/NetworkTable.h"
#include "networktables/NetworkTableInstance.h"
#include "networktables/NetworkTableEntry.h"
#include "Limelight.h"

class Autonomous {
public:
    Autonomous(Drive* drive, GamePiece* gamePiece);

    Drive* drive;
    GamePiece* gamePiece;
    
    void process();

    void debug(Feedback* feedback);

    enum AutoMode{DONOTHING, CROSS_PORT, DRIVE_RIGHT_MORE, SHOOT_FROM_LINE, JUST_LINE, DRIVE_LEFT, FIVE_BALL_AUTO, AUTO_AIM,
    CROSS_PORT_TRENCH, // Testing o0o0o0o0o0o0o0o0o0o0o0o0o
    };
    AutoMode currentAutoMode = AutoMode::DONOTHING;

	void sendModesToDashboard();

	void getModeFromDashboard();

    void doStartupThings();

     void reset();


private:
    frc::Timer timer;
    frc::Timer timer2;
    int gameData;
    int step = 0;
    int trenchStep = -1;
    void doNothing();
    void shoot();
    void crossLine();
    void driveRightMore();
    void driveRight();
    void shootLine();
    void justLine();
    void driveLeft();
    void trenchBalls(); // Used after going to Power port
    void fiveBallAuto();
    void autoAim();

    enum StartPosition {LEFT, RIGHT, CENTER};
    enum limelightState {AIMED, NOT};
    limelightState state = limelightState::NOT;
    StartPosition position;

    void handleDashboardString(AutoMode mode, const char* description, char* buffer);

    Limelight limelight{};

};


