#pragma once

#include <fstream>
#include <iostream>
#include <frc/Timer.h>

class Log {
public:
    Log(const char* filename);

    /**
     * Starts/stops writing to file
     * if true, log to file
     * if false, stop, close file/save
     */
    void toggleWrite(bool writing);

    void process();

    void setBallCount(int count);
    void setIntakeSensor(bool intake);
    void setHelixSensor(bool helix);
    void setShooterCounter(int counter);
    void setShooterState(int shooterState);
    void setIntakeState(int intakeState);
    void setIntakeCurrent(double current);

private:
    std::ofstream outputFile;
    const char* filename;
    bool writing = false;

    frc::Timer timer{};

    int ballCount = -1;
    bool intakeSensor = false;
    bool helixSensor = false;
    int shooterCounter = -1;
    int shooterState = -1;
    int intakeState = -1;
    double intakeCurrent = -1;

};